<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>People database</title>
  
  <style>
    /* Styling for our table */
    table.people {
      font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
      border-collapse: collapse;
      width: 100%;
    }

    table.people td, th {
      border: 1px solid #ddd;
      padding: 8px;
    }

    table.people tr:nth-child(even){
      background-color: #f2f2f2;
    }

    table.people tr:hover {
      background-color: #ddd;
    }

    table.people th {
      padding-top: 12px;
      padding-bottom: 12px;
      text-align: left;
      background-color: #0f1cd6;
      color: white;
    }

    /* Styling for our input form */
    input[type=text] {
      width: 100%;
      padding: 12px 20px;
      margin: 8px 0;
      display: inline-block;
      border: 1px solid #ccc;
      border-radius: 4px;
      box-sizing: border-box;
    }

    input[type=submit] {
      width: 100%;
      background-color: #4CAF50;
      color: white;
      padding: 14px 20px;
      margin: 8px 0;
      border: none;
      border-radius: 4px;
      cursor: pointer;
    }

    input[type=submit]:hover {
      background-color: #45a049;
    }

    div {
      border-radius: 5px;
      background-color: #f2f2f2;
      padding: 20px;
    }
    
  </style>
</head>

<body>
  <h1>People Database</h1>
  <!-- 
    Specify the table that will be used to display the people database
  -->
  <table class="people">
    <tr>
      <th>Name</th>
      <th>Birthday</th>
      <th>Occupation</th>
    </tr>
  </table>
  <br/>

  <!-- 
    Specify the user input form. Upon submission, the form will
    call the route `/person` with method `POST`. This will trigger
    the `func createPersonHandler` defined in `personHandler.go` file.
   -->
  <div>
    <form action="/person" method="post">
      <h3>Add new person</h3>
      Name:
      <input type="text" name="nama">
      <br/>Birthday:
      <input type="text" name="birthday">
      <br/> Occupation:
      <input type="text" name="occupation">
      <br/>
      <input type="submit" value="Submit">
    </form>
  </div>

  <!-- 
    Script runs on each page load to update the people database
   -->
  <script>
    personTable = document.querySelector("table")
    // Use the browsers `fetch` API to make a GET call to `/person` route. This 
    // will trigger the `func getPersonHandler` defined in `personHandler.go` file.
    // The received response is a JSON list of persons.
    fetch("/person")
      .then(response => response.json()) // Read the JSON body of the response
      .then(personList => {
        personList.forEach(person => {
          // Create the table row
          row = document.createElement("tr") 
          // Create the table data elements and extract corresponding values from received `person`
          nama = document.createElement("td") 
          nama.innerHTML = person.nama
          birthday = document.createElement("td")
          birthday.innerHTML = person.birthday
          occupation = document.createElement("td")
          occupation.innerHTML = person.occupation
          // Add the data elements to the row
          row.appendChild(nama)
          row.appendChild(birthday)
          row.appendChild(occupation)
          // Add the row element to the table
          personTable.appendChild(row)
        })
      })
  </script>
</body>

</html>